/*
безусловные рефлексы
*/

package reflexes

import (
	"BOT/lib"
	"strconv"
	"strings"
)
/////////////////////////////////////////

////////////////////////////////////////
func init(){
	loadTerminalActons()
	loadGeneticReflexes()

	loadImagesArrs()

	initReflexTree()
}
/////////////////////////////////////////



////////////////////////////////////////////
type GeneticReflex struct {
	ID int
	lev1 int
	lev2 []int
	lev3 []int
	ActionIDarr []int
// Result int - у безусловных рефлексов нет конкуренции, кроме того, что они подавляются более высокоуровневыми рефлексами и автоматизмами
}
var GeneticReflexes=make(map[int]*GeneticReflex)

//////////////////////////////////////////
var lastGeneticReflexID=0
func createNewGeneticReflex(id int,lev1 int,lev2 []int,lev3 []int,ActionIDarr []int)(int,*GeneticReflex){
	// посмотреть, если рефлекс с такими же условиями уже есть
	idOld,rOld:=compareUnicum(lev1,lev2,lev3)
	if idOld>0{
		return idOld,rOld
	}

	if id==0{
		lastGeneticReflexID++;
		id=lastGeneticReflexID
	}else{
		//		newW.ID=id
		if lastGeneticReflexID<id{
			lastGeneticReflexID=id
		}
	}

	var newW GeneticReflex
	newW.ID = id
	newW.lev1 = lev1
	newW.lev2 = lev2
	newW.lev3 = lev3
	newW.ActionIDarr=ActionIDarr
	GeneticReflexes[id]=&newW
	return id,&newW
}
// посмотреть, если рефлекс с такими же условиями уже есть
func compareUnicum(lev1 int,lev2 []int,lev3 []int)(int,*GeneticReflex){
	for k, v := range GeneticReflexes {
		if v.lev1==lev1 && lib.EqualArrs(v.lev2,lev2) && lib.EqualArrs(v.lev3,lev3){
			return k, v
		}
	}
	return 0,nil
}
////////////////////////////////////////////////////////

// P.S. безусловные рефлексы создаются в редакторе и поэтому здесь нет функции их сохранения.
// а только загрузка имеющихся в формате ID|lev1|lev2_1,lev2_2,...|lev3_1,lev3_2,...|actin_1,actin_2,...:
func loadGeneticReflexes(){
	path:=lib.GetMainPathExeFile()
	lines,_:=lib.ReadLines(path+"/memory_reflex/dnk_reflexes.txt")
	for i := 0; i < len(lines); i++ {
		if len(lines[i])<4{
			continue
		}
		p:=strings.Split(lines[i], "|")
		id,_:=strconv.Atoi(p[0])
		lev1,_:=strconv.Atoi(p[1])
		// второй уровень
		pn:=strings.Split(p[2], ",")
		var lev2 []int
		for i := 0; i < len(pn); i++ {
			b,_:=strconv.Atoi(pn[i])
			if b>0 {
				lev2 = append(lev2, b)
			}
		}
		createNewBaseStyle(0,lev2)
		// третий уровень
		pn=strings.Split(p[3], ",")
		var lev3 []int
		for i := 0; i < len(pn); i++ {
			b,_:=strconv.Atoi(pn[i])
			if b>0 {
				lev3 = append(lev3, b)
			}
		}
		// создать образ сочетаний пусковых стимулов
		//actID,_:=createNewlastTriggerStimulsID(0,lev3,nil,0,0)
		pn=strings.Split(p[4], ",")
		var ActionIDarr []int
		for i := 0; i < len(pn); i++ {
			b,_:=strconv.Atoi(pn[i])
			if b>0 {
				ActionIDarr = append(ActionIDarr, b)
			}
		}
		createNewGeneticReflex(id,lev1,lev2,lev3,ActionIDarr)
	}
	return
}
///////////////////////////////////////////////////////////////////////////

