/*  Выдать на Пульт акции Бота

вывести на Пульт действия Бота строкой lib.SentActionsForPult("xcvxvxcv")
Каждая акция - в формате: вид действия (1 - действие рефлекса, 2 - фраза) затем строка акции,
например: "1|Предлогает поиграть" или "2|Привет!"
Можно передавать неограниченную последовательность акций, разделяя их "||"
например: "1|Предлогает поиграть||2|Привет!"
*/

package reflexes

import (
	"BOT/brain/action_sensor"
	"BOT/brain/gomeostas"
	"BOT/lib"
	"sort"
	"strconv"
	"strings"
)

////////////////////////////////////////////////////////////////////

/* Образы сочетаний действий Бота - при выполнении рефлексов или автоматизмов
*/
// последний образ сочетаний действий Бота
var ActivedTerminalImage []int // массив действий Бота
// предыдущий  образ сочетаний действий Бота
var oldActivedTerminalImage []int
// сохранить образ действий, обеспечивая сортировку ID в массиве
func UpdateActivedTerminalImage(actionsIdArr []int){
// сохранить предыдущий образ
	oldActivedTerminalImage=nil
	//for _, v := range ActivedTerminalImage {
	for i := 0; i < len(ActivedTerminalImage); i++ {
		oldActivedTerminalImage=append(oldActivedTerminalImage,ActivedTerminalImage[i])
	}
// сохранить текущий образ, обеспечивая сортировку ID в массиве
	ActivedTerminalImage=nil
	sort.Ints(actionsIdArr)
	//for _, v := range actionsIdArr {
	for i := 0; i < len(actionsIdArr); i++ {
		ActivedTerminalImage=append(ActivedTerminalImage,actionsIdArr[i])
	}
	return
}
//////////////////////////////////////////




// выдать на Пульт подряд акции одного безусловного рефлекса
func TerminateGeneticReflaxActions(id int){
	if id==0{
		return
	}
	reflex:=GeneticReflexes[id]
	if reflex==nil{return}
// сохранить образы сочетаний действий
	UpdateActivedTerminalImage(reflex.ActionIDarr)

	var out="1|"
	for i := 0; i < len(reflex.ActionIDarr); i++ {
		if i>0{out +=", "}
		out += TerminalActonsNameFromID[reflex.ActionIDarr[i]]
	}
lib.SentActionsForPult(out)
	return
}
/////////////////////////////////////////////

// выдать на Пульт подряд акции массива ID БЕЗУСЛОВНЫХ рефлексов
// reflexKind: 1-древний безусловный, 2-новый безусловный, 2-условный
func TerminateGeneticAllReflaxActions(reflexesIdArr []int,reflexKind int){
	if reflexesIdArr==nil{
		return
	}
	var out="1|<b>БЕССМЫСЛЕННЫЙ безусловный рефлекс:</b><br>"
	// оставить только уникальные действия рефлексов и выдать такой список
	var unicumArr=make(map[int]int)
	for i := 0; i < len(reflexesIdArr); i++ {
		reflex:=GeneticReflexes[reflexesIdArr[i]]
		for j := 0; j < len(reflex.ActionIDarr); j++ {
			unicumArr[reflex.ActionIDarr[j]]=1
		}
	}
	var n=0
	var aImage []int
	for k, _ := range unicumArr {
// корректировка для Действия "Кормится"
		k=removingActionForFood(k)

		if n>0{out +=", "}
		out += TerminalActonsNameFromID[k]
// при этом меняются гомео-параметры:
		ExpensesGomeostatParametersAfterAction(k)

		aImage=append(aImage,k)
		n++
	}
	// сохранить образы сочетаний действий
	UpdateActivedTerminalImage(aImage)

	// детектор нового вычленяет новые условия по сравненеию с условиями рефлекса и обрабатывает это:
// здесь ВСЕГДА rank=0 т.к. тут обрабатываются только безусловные
	updateNewsConditions(0)

	lib.SentActionsForPult(out)

	// очистить массивы рефлексов данного типа
	switch reflexKind{
	case 1: oldReflexesIdArr=nil
	case 2: geneticReflexesIdArr=nil
// здесь не бывает	case 3: conditionReflexesIdArr=nil
	}

	return
}
//////////////////////////////////
func TerminateConditionAllReflaxActions(reflexesIdArr []int){
	if reflexesIdArr==nil{
		return
	}
	var out="1|<b>БЕССМЫСЛЕННЫЙ условный рефлекс:</b><br>"

// может быть только один член в reflexesIdArr
	reflex:=ConditionReflexes[reflexesIdArr[0]]
	var n=0
	var aImage []int
// здесь не может быть неуникальных ID действий, так что просто:
	for i := 0; i < len(reflex.ActionIDarr); i++ {
		k:=reflex.ActionIDarr[i]
		// корректировка для Действия "Кормится"
		k = removingActionForFood(k)

		if n > 0 {
			out += ", "
		}
		out += TerminalActonsNameFromID[k]
		// при этом меняются гомео-параметры:
		ExpensesGomeostatParametersAfterAction(k)

		aImage=append(aImage,k)
		n++
	}
	// сохранить образы сочетаний действий
	UpdateActivedTerminalImage(aImage)

	// детектор нового вычленяет новые условия по сравненеию с условиями рефлекса и обрабатывает это:
	// для создания условных рефлексов более высого ранга на основе усл.рефлексов
	rank:=ConditionReflexes[reflex.ID].rank
	updateNewsConditions(rank+1)

	lib.SentActionsForPult(out)

	conditionReflexesIdArr=nil
}
//////////////////////////////////////////


// корректировка для Действия "Кормится"
func removingActionForFood(actionID int)(int){
	// если Бот пытается поесть
	if actionID==5{
		res:=botEatingFood()
		if res==0{// если нет еды
			actionID=77 //нет еды! Накорми!
		}
		if res==2{// уже насен и не может есть
			actionID=78 // не хочу больше есть
		}
	}
	return actionID
}

////////////////////////////////////
// выдать на Пульт подряд акции массива по каждому рефлексу отдельной строкой действий
/*
func TerminateGeneticEachReflaxActions(reflexesIdArr []int){
	if reflexesIdArr==nil{
		return
	}
	var out=""
	for i := 0; i < len(reflexesIdArr); i++ {
		if i>0{out+="||"} // пошел следующий рефлекс
		reflex:=GeneticReflexes[reflexesIdArr[i]]
		if reflex==nil{return}
		out+="1|"
		for j := 0; j < len(reflex.ActionIDarr); j++ {
			if j>0{out +=", "}
			out += TerminalActonsNameFromID[reflex.ActionIDarr[j]]
		}
	}
	lib.SentActionsForPult(out)
}
 */
///////////////////////////////////////////////





/* затратные последствия ответного действия
т.е. то, как изменятся параметры гомеостаза при совершении данного действия
*/
type TerminalActionsExpenses struct {
	gomeoID int // ID затрагиваемого параметра гоместаза
	diff float64 // на сколько изменится параметр
}

// имя ответного действия по его ID
var TerminalActonsNameFromID=make(map[int]string)
// затратные последствия ответного действия по его ID
var TerminalActionsExpensesFromID=make(map[int][]TerminalActionsExpenses)
func loadTerminalActons(){
	TerminalActonsNameFromID=make(map[int]string)
	lines,_:=lib.ReadLines(lib.GetMainPathExeFile()+"/memory_reflex/terminal_actons.txt")
	for i := 0; i < len(lines); i++ {
		p := strings.Split(lines[i], "|")
		id, _ := strconv.Atoi(p[0])
		TerminalActonsNameFromID[id]=p[1]
		//это действия приводит к изменению гомео-параметров:
		var expenses []TerminalActionsExpenses
		se := strings.Split(p[2], ";")
		for j := 0; j < len(se); j++ {
			if len(se[j])==0{
				continue
			}
			e := strings.Split(se[j], ">")
			e1,_:=strconv.Atoi(e[0])
			e2,_:=strconv.ParseFloat(e[1], 64);
			expenses=append(expenses,TerminalActionsExpenses{e1,e2})
		}
		TerminalActionsExpensesFromID[id]=expenses
	}
	return
}
////////////////////////////////////////////

// изменение гомео-параметров при действии
func ExpensesGomeostatParametersAfterAction(actID int){
	se :=TerminalActionsExpensesFromID[actID]
	if se != nil {
		for j := 0; j < len(se); j++ {
			gomeostas.GomeostazParams[se[j].gomeoID]+=se[j].diff
			if gomeostas.GomeostazParams[se[j].gomeoID]>100{
				gomeostas.GomeostazParams[se[j].gomeoID]=100
			}
			if gomeostas.GomeostazParams[se[j].gomeoID]<0{
				gomeostas.GomeostazParams[se[j].gomeoID]=0
			}
		}
	}
}
/////////////////////////////////////////////



////////////  БОТ кормится из выданной порции
// один акт кормления пополняет энергию на 30%
func botEatingFood()(int){
	// сколько сможет съесть? сколько отсалось до 100
	energi:=gomeostas.GomeostazParams[1]
	can:=100-gomeostas.GomeostazParams[1]
	if energi>95{// больше не хочет есть
		return 2
	}
	var portion=30
	if can<30{
		portion=int(30-can)
	}

	if action_sensor.FoodPortionForEnergi>=portion{// еды больше порции
		// сколько Бот уже съел и нужно превратить в энергию (сразу писать нельзя из-за паники: "concurrent map read and map write")
		gomeostas.FoodPortionEaten+=action_sensor.FoodPortionForEnergi // еда - в энергию
		action_sensor.FoodPortionForEnergi-=portion
		if action_sensor.FoodPortionForEnergi<0{
			action_sensor.FoodPortionForEnergi=0
		}
		return 1
	}else{// еды меньше порции
		if energi<10 && action_sensor.FoodPortionForEnergi<10{
			gomeostas.FoodPortionEaten+=action_sensor.FoodPortionForEnergi // еда - в энергию
			action_sensor.FoodPortionForEnergi=0
			return 0
		}
		if action_sensor.FoodPortionForEnergi < portion{
			portion=action_sensor.FoodPortionForEnergi
		}
		gomeostas.FoodPortionEaten+=portion
		action_sensor.FoodPortionForEnergi-=portion // еда - в энергию
		if action_sensor.FoodPortionForEnergi<0{
			action_sensor.FoodPortionForEnergi=0
		}
		return 1
	}


	return 0
}
/////////////////////////////////////////////



