/* пока дерева рефлексов на Пульте

*/

package reflexes

import (
	actionSensor "BOT/brain/action_sensor"
	"BOT/brain/gomeostas"
	"strconv"
)

// образ дерева рефлексов для вывода
var reflesTreeModel=""
/////////////////////////////////////////////////
func GetReflexesTreeForPult()(string){
	// против паники типа "одновременная запись и считывание карты"
	if notAllowScanInReflexesThisTime{
		return "!!!"
	}
	reflesTreeModel=""
	scanReflexesNodes(-1,&ReflexTree)

	return reflesTreeModel

	return ""
}
//////////////////////

func scanReflexesNodes(level int,node *ReflexNode){
	if node.ID==69{
		node.ID=69
	}
	if node.ID>0 {
		reflesTreeModel += setShift(level)
		switch level{
		case 0:
			reflesTreeModel += getStrFromCond(1,node.baseID) + "(nodeID=" + strconv.Itoa(node.ID) + ")"
		case 1:
			reflesTreeModel += getStrFromCond(2,node.StyleID) + "(nodeID=" + strconv.Itoa(node.ID) + ")"
		case 2:
			if node.ActionID==0{// древний рефлекс - без пусковыого стимула
				reflesTreeModel += getStrFromCond(2,node.StyleID) + "(nodeID=" + strconv.Itoa(node.ID) + ")"
			}else {
				reflesTreeModel += getStrFromCond(3, node.ActionID) + "(nodeID=" + strconv.Itoa(node.ID) + ")"
			}

		case 3:
			reflesTreeModel += getStrFromCond(3, node.ActionID) + "(nodeID=" + strconv.Itoa(node.ID) + ")"
		}

		// если есть рефлекс - показать действия
		if node.ConditionedReflex>0{
			//rID:=ConditioneReflexes[node.ConditionedReflex]
		}else if node.GeneticReflexID>0{
			reflex:=GeneticReflexes[node.GeneticReflexID]
			if reflex.ID==45{
				reflex.ID=45
			}
			reflesTreeModel += " <span style='color:blue'>Рефлекс(" + strconv.Itoa(reflex.ID) + "): "+getReflexActionsStrFromID(reflex) + "</span>"
		}
		reflesTreeModel +="<br>\n"
	}
	level++
	for n := 0; n < len(node.Children); n++ {
		scanReflexesNodes(level,&node.Children[n])
	}
}
// отступ
func setShift(level int)(string){
	var sh=""
	for n := 0; n < level; n++ {
		sh+="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
	}
	return sh
}
////////////////////////////////////////////////////




/////////////////////////////////////////////////////
// из ID образа получить составляющие в виде строк
func getStrFromCond(level int,imgID int)(string){
	var out=""
	switch level{
	case 1: if imgID>0 && imgID<4{ out=gomeostas.GetBaseCondFromID(imgID)
	}else{
		out += "<span style='color:red'>несуществующее Базовое состояние ID="+strconv.Itoa(imgID)+"</span>"
	}
	case 2:
		out=getStrnameFromBaseImageID(imgID)
	case 3: out=getStrnameFromStyleImageID(imgID)
	}
	return out
}
// названия базовых контекстов в их сочетании -из ID их образа
func getStrnameFromBaseImageID(id int)(string){
	var out=""
	img:=BaseStyleArr[id]
	for i := 0; i < len(img.BSarr); i++ {
		if i>0{out +=", "}
		name:=gomeostas.GetBaseContextCondFromID(img.BSarr[i])+""
		if len(name)==0{
			out += "<span style='color:red'>несуществующий Базовый контекст ID="+strconv.Itoa(img.BSarr[i])+"</span>"
		}else {
			out +=name
		}
	}
	return out
}
// названия Пусковых стимулов в их сочетании -из ID их образа
func getStrnameFromStyleImageID(id int)(string){
	var out=""
	if id==0{return ""}
	img:=TriggerStimulsArr[id]
	if img==nil{return ""}
	// Действия с Пульта?
	if len(img.RSarr)>0 {
		for i := 0; i < len(img.RSarr); i++ {
			if i>0{out +=", "}
			name:=actionSensor.GetActionNameFromID(img.RSarr[i])
			if len(name)==0{
				out += "<span style='color:red'>несуществующий стимул ID="+strconv.Itoa(img.RSarr[i])+"</span>"
			}else {
				out +=name
			}
		}
	}
	// фразы с Пульта?
	if len(img.PhraseID)>0 {
		out +="Фразы c ID: "
		for i := 0; i < len(img.PhraseID); i++ {
			if i>0{out +=", "}
			out += strconv.Itoa(img.PhraseID[i])
		}
	}
	return out
}
/////////////////////////////////////////////

func getReflexActionsStrFromID(reflex *GeneticReflex)(string){
	if reflex==nil{return ""}
	var out=""
	for i := 0; i < len(reflex.ActionIDarr); i++ {
		if i>0{out +=", "}
		out += TerminalActonsNameFromID[reflex.ActionIDarr[i]]
	}
	return out
}
/////////////////////////////////////////////