/*  распознаватель слов и фраз по типу зоны Вернике в мозге.

С ПУльта приходит текст, который в VerbalDetection() разбирается на аюзацы (\r\n)
абзацы в PhraseSeparator() разбираются на фразы по разделителям (знаки препинания)
фразы в WordDetection() разбиваются на слова.
Распознанные (и нераспознанные) последовательности сохраняются в оперативной памяти Бота MemoryDetectedArr.
где распознанный текст представлен в виде уникального laslID фразы
Нераспознанной фразы НЕ БЫВАЕТ т.к. она тут же создается
*/


package word_sensor

import (
	"BOT/brain/gomeostas"
	_ "BOT/lib"
	"regexp"
	"strconv"
	"strings"
)

// запрет показа карт WordTreeFromID и PhraseTreeFromID во время распознавания и записи
// против паники типа "одновременная запись и считывание карты"
var notAllowScanInThisTime=false

// подошла очередь инициализации
func afetrInitPhraseTree(){
	wordRecognizerInit() //

	//	VerbalDetection("привет новая абзаца",1) // текст с пульта
	//  PhraseSeparator("привет") // распознавание фразы
		// WordDetection("привет") // распознавание слова

	isReadyWordSensorLevel=1
	initWordPult()
	initPrasePult()
}
//////////////////////////////////////////////

// индикация, что дерево загружено, можно вводить тексты
var isReadyWordSensorLevel=0
func IsReadyWordSensorLevel()(bool){
if isReadyWordSensorLevel>0{// связь с корнями проекта
	return true
}
return false
}

//////////////////////////////////////////  word_sensor.VerbalDetectin("активностный")



//для использования в SetNewWordTreeNode




/* здесь набирается массив lastID распознанных фраз.
*/
var CurrentPhrasesIDarr []int
// настроение с ПУльта при передаче фразы
var CurPultMood=0
// текущий тон фразы: 0 - обычный, 1 - восклицательный, 2- вопросительный
var DetectedTone=0


// Память о воспринятых фразах в текущем активном контексте:
type MemoryDetected struct {
	//распознанный текст в виде lastID выделенных фраз
	PhrasesID []int // массив структур распознанных фраз
	Tone int //Тон: 0 - обычный, 1 - восклицательный, 2- вопросительный
	Mood int // настроение при передаче фразы с Пульта: -повышенный -нормальный -вялый Хорошее    -Плохое    -Игровое    -Учитель    -Агрессивное   -Защитное    -Протест
	// индекс==ID активного базового контекста, значение - вес этого контекста
	ActveContextWeight map[int]int
}
//  массив памяти накапливается в течении дня, обрабатывается и очищается во сне
var MemoryDetectedArr []MemoryDetected
func addNewMemoryDetected(){
var new MemoryDetected
	new.PhrasesID=CurrentPhrasesIDarr
	new.Tone=DetectedTone // знак конца фразы: 0 - обычный, 1 - восклицательный, 2- вопросительный
	new.Mood=CurPultMood // настроение с Пульта: -повышенный -нормальный -вялый  -Хорошее    -Плохое    -Игровое    -Учитель    -Агрессивное   -Защитное    -Протест
	new.ActveContextWeight=gomeostas.GetActiveContextInfo()
	MemoryDetectedArr=append(MemoryDetectedArr,new)
}
//////////////////////////////////////////////






/*  распознавание фразы с Пульта - бывает только в нижнем регистре

 */
var wlev=0
var pultOut=""
var noCheckWordCount=false
// вызывается фразой с Пульта
func VerbalDetection(text string,isDialog int,moodID int)(string) {
	notAllowScanInThisTime=true // запрет показа карты при обновлении
	noCheckWordCount=false
	CurrentPhrasesIDarr=nil
	if isDialog==0{// это набивка работчих фраз без отсеивания мусорных слов
// игнорировать getWordTemparrCount и всегда распознавать слова
		noCheckWordCount=true
	}

	CurPultMood=moodID

	pultOut=""
	// стандартно разделить текст на короткие фразы, отправить на накопление
	// разделяем на фразы
	strArr:=strings.Split(text, "|#")// а не |#| - чтобы оставлять разделитель "|"
	for i := 0; i < len(strArr); i++ {
		if i>0{
			pultOut+="<br>"
		}
		str:=addNewtempArr(strArr[i])
		for n := 0; n < len(str); n++ {
			if n>0{
				pultOut+=" "
			}
			pultOut+=PhraseSeparator(str[n])
			if DetectedUnicumPhraseID>0{// распознанная фраза
				CurrentPhrasesIDarr=append(CurrentPhrasesIDarr,DetectedUnicumPhraseID)
			}else{
				// нераспознанной фразы НЕ БЫВАЕТ т.к. она тут же создается
			}
		}
	}

	// добавить в стек памяти распознанных
	addNewMemoryDetected()

//	reflexes.ActiveFromPhrase() // активировать дерево рефлексов фразой - только для условных рефлексов

	// ответ на Пульт:
	notAllowScanInThisTime=false
	return pultOut
}
////////////////////////////////////////////





// проход одной фразы (т.е. по разделителям в предложении, а не пр \r\n)
func PhraseSeparator(text string)(string){
var pultOut=""
	// чистим лишние пробелы
	rp := regexp.MustCompile("s+")
	text = rp.ReplaceAllString(text, " ")
	text = strings.TrimSpace(text)

	wordsArr:=GetWordIDfromPhrase(text)
	str:=PhraseDetection(wordsArr)  // распознаватель фразы
	pultOut+=str+"("+strconv.Itoa(DetectedUnicumPhraseID)+")"

	// тон сообщения
	DetectedTone=0
	if strings.Contains(text, "!") {
		DetectedTone = 1
	}
	if strings.Contains(text, "?") {
		DetectedTone = 2
	}



return pultOut
}
//////////////////////////////////////////////



















