/*
индексная страница http://localhost:8181/index
*/

package main

import (
	"BOT/brain"
	"BOT/brain/action_sensor"
	"BOT/brain/gomeostas"
	"BOT/brain/reflexes"
	word_sensor "BOT/brain/words_sensor"
	"BOT/closer"
	"BOT/lib"
	"fmt"
	"log"
	"net/http"
	"strconv"
	"strings"
)

/* В проекте много глобальных переменных, что привычно раздражает Свидетелей инкапсуляции и непорочного пространства имен,
но ТАК НУЖНО (спорно) для одганизации среды,
схожей с организацией линкующих указателей в мозге (т.е. связей с одного распознавателя к целому ансаблю - объекту).
Ну и есть немало других вещей, нарушающих Порядок и Традиции Golang.
Попытки использовать горутины оказались просто неуместными (спорно) и просто ненужными, учитывая вряд ли в чем-то могущий быть выигрыш.
Короче, код предоставляется на вольное растерзание и свободное экспериментирование, без претензий, сорри за возможный негатив.
Везде много пространных комментариев, которые запутывают даже меня, но они НУЖНЫ.
*/
var isGlobalStopAllActivnost=false // true - остановка всей активности для совершения критических глобальных операций

func receiveSend(resp http.ResponseWriter, r *http.Request) {
	resp.Header().Set("Access-Control-Allow-Origin", "*")
	resp.Header().Set("Access-Control-Allow-Headers", "Content-Type")

// посылается постоянно раз в 1сек (из /common/linking.php) или с запросом или для подтверждения связи,
//а так же для передачи по текущему пульсу информации от Бота, например WritePultConsol()
	if r.Method == "POST" {

		if !isGlobalStopAllActivnost {

			// 	текстовый блок для набивки дерева слов-фраз из http://go/pages/words.php
			text_block := r.FormValue("text_block")
			if len(text_block) > 0 {
				res := word_sensor.SetNewTextBlock(text_block)
				_, _ = fmt.Fprint(resp, res)
				return
			}
			////////////////////////////////////////////////////////

			text_dlg := r.FormValue("text_dlg")
			if len(text_dlg) > 0 {
				is_input_rejim, _ := strconv.Atoi(r.FormValue("is_input_rejim"))
				pult_mood := r.FormValue("pult_mood")
				moodID, _ := strconv.Atoi(pult_mood)
				res := word_sensor.VerbalDetection(text_dlg, is_input_rejim, moodID)

				reflexes.ActiveFromPhrase() // активировать дерево рефлексов фразой - только для условных рефлексов

				_, _ = fmt.Fprint(resp, res)
				return
			}

			// отправить на пульт состояние гомеостаза бота и его базовые контексты
			getParams := r.FormValue("get_params")
			if len(getParams) > 0 {
				outStr := gomeostas.GetCurGomeoParams()

				outStr += "#|#" + gomeostas.GetCurGomeoStatus() + "#|#" + gomeostas.GetCurContextActive() +
					"#|#" + strconv.Itoa(action_sensor.FoodPortionForEnergi)
				/*
					cntx,dominanta:=gomeostas.GetCurContextMap()
					//fmt.Println(cntx)
					outStr +="#|#"+cntx+"#|#"+dominanta
					//  ХУЖЕ-ЛУЧШЕ:
					//  fmt.Println("Состояние: ",brain.CurrentWellAndBadvalue," ХУЖЕ-ЛУЧШЕ: ",brain.DetectorWellAndBad," ВЕС ИЗМЕНЕНИЙ: ",brain.DetectorWellAndBadWeight);
					outStr +="#|#"+strconv.Itoa(brain.DetectorWellAndBad)
					// состояние периода доминирующего контекста (действие эмпатии
					outStr +="#|#"+strconv.Itoa(brain.IsDomContext)
					// список текущих активных рефлексов
					outStr +="#|#"+brain.ReflexesListActive
					// скорость потери энергии
					outStr +="#|#"+fmt.Sprintf("%10.1f",brain.SpeedEnergi)
					// текущие события - на консоль Пульта
					outStr +="#|#"+brain.WritePultConsolStr
					brain.WritePultConsolStr="" // обнулять переданный пакет
					// эмоция Бота:
					outStr +="#|#"+brain.GetBotEmotion()
					// последние эмпатийные события
					outStr +="#|#"+brain.StackEmpatiaActivnost
					if brain.LastActiveTreeNode!=nil{
						outStr +="#|#"+strconv.Itoa(brain.LastActiveTreeNode.ID) // 10-я переменная
					}else{
						outStr +="#|#0"
					}
					// список новых слов
					wStr:=brain.GetCurrentUnknownWords()
					if len(wStr)>0 {
						outStr += "#|#" + wStr // 11-я переменная
					}else{outStr +="#|#0"}
				*/
				//fmt.Println(outStr)
				_, _ = fmt.Fprint(resp, outStr)
				return
			}

			// установка параметров гомеостаза с Пульта:
			// задать параметры гомеостаза бота
			setParamsId := r.FormValue("set_params")
			if len(setParamsId) > 0 {
				id, _ := strconv.Atoi(setParamsId)
				gomeostas.SetCurGomeoParams(id, r.FormValue("params_val"))
				_, _ = fmt.Fprint(resp, "1")
				return
			}

			//  передача информации от Бота в Пульт различается идентификатором назначения информации перед самой информацией
			// информация для консоли ничинается с идентификатора назначения: "CONSOL:"
			if len(lib.WritePultConsolStr) > 0 {
				_, _ = fmt.Fprint(resp, "CONSOL:"+lib.WritePultConsolStr)
				lib.WritePultConsolStr = "" // очистка для новой порции
				return
			}

			// информация о действиях БОТА ничинается с идентификатора назначения: "ACTION:"
			if len(lib.ActionsForPultStr) > 0 {
				_, _ = fmt.Fprint(resp, "ACTION:"+lib.ActionsForPultStr)
				lib.ActionsForPultStr = "" // очистка для новой порции
				return
			}

			///////////////////////////////////////
			// если ничего выше не было, то:
			// передача на Пульт сигнала готовности - когда нет других запросов - посылаетс сигнал на Пульт в function bot_answer(res)
			if word_sensor.IsReadyWordSensorLevel() {
				//идентификатор назначения информации: "READY"
				_, _ = fmt.Fprint(resp, "READY")
				return
			}

			_, _ = fmt.Fprint(resp, "POST")

		}
		//fmt.Println("EMPTY")
	}

////////////////////////////////////////////////////////////////////////
	if r.Method == "GET" {
			// остановка любой активности Бота
			stop_activnost := r.FormValue("stop_activnost")
			if stop_activnost == "1" {
				isGlobalStopAllActivnost=true
				_, _ = fmt.Fprint(resp, "stop")
				return
			}
		// остановка любой активности Бота
		start_activnost := r.FormValue("start_activnost")
		if start_activnost == "1" {
			isGlobalStopAllActivnost=false
			_, _ = fmt.Fprint(resp, "stop")
			return
		}
		// ЗОНА ОСОБЫХ ДЕЙСТВИЙ в период остановленной активности Бота:

		// Сохранить текущее состояние Бота
		save_all_memory := r.FormValue("save_all_memory")
		if save_all_memory == "1" {
			if brain.SaveAll() {
				_, _ = fmt.Fprint(resp, "yes")
				return
			}
			_, _ = fmt.Fprint(resp, "no")
			return
		}
		////////////////////////////
		// корректное выключение Бота
		bot_closing := r.FormValue("bot_closing")
		if bot_closing == "1" {
			cleanupFunc()
			closer.Close()
			return
		}



		////////////////////////////////////////////
		if !isGlobalStopAllActivnost {

			get_reflex_tree := r.FormValue("get_reflex_tree")
			if get_reflex_tree == "1" {
				tree := reflexes.GetReflexesTreeForPult()
				if tree == "!!!" {
					return // запрет показа карты во время распознавания и записи
				}
				_, _ = fmt.Fprint(resp, tree)
				return
			}
			////////////////////////////////////////////

			get_phrase_tree := r.FormValue("get_phrase_tree")
			if get_phrase_tree == "1" {
				phTree := word_sensor.GetPhraseTreeForPult()
				if phTree == "!!!" {
					return // запрет показа карты во время распознавания и записи
				}
				_, _ = fmt.Fprint(resp, phTree)
				return
			}
			////////////////////////////////////////////
			get_word_tree := r.FormValue("get_word_tree")
			if get_word_tree == "1" {
				phTree := word_sensor.GetWordTreeForPult()
				if phTree == "!!!" {
					return // запрет показа карты во время распознавания и записи
				}
				_, _ = fmt.Fprint(resp, phTree)
				return
			}
			////////////////////////////////////////////
			set_action := r.FormValue("set_action")
			if len(set_action) > 0 {
				action, _ := strconv.Atoi(set_action)
				foodPortion, _ := strconv.Atoi(r.FormValue("food_portion"))
				action_sensor.SetActionFromPult(action, foodPortion)

				//// активировать дерево действием
				reflexes.ActiveFromAction()

				_, _ = fmt.Fprint(resp, "!")
				return
			}
			_, _ = fmt.Fprint(resp, "GET")
		}
	}

}

func init(){



	lib.GetMainPathExeFile()
	log.SetFlags(log.Lshortfile | log.LstdFlags)
}


func main() {
	defer closer.Close()
	// для перехвата при завершении программы (использует пакет "BOT/closer" https://github.com/xlab/closer):
	closer.Bind(cleanupFunc)
	/*
		go func() {// автоматическое закрытие через 10 секунд после запуска:
			// do some pseudo background work
			//fmt.Println("10 seconds to go...")
			//time.Sleep(10 * time.Second)
			//closer.Close()
		}()
	*/
	////////////////////////////////////////
	address:=lib.ReadFileContent(lib.GetMainPathExeFile()+"/common/linking_address.txt")
	address=strings.TrimSpace(address)[7:]
	http.HandleFunc("/", receiveSend)
	//_ = http.ListenAndServe("go:8181", nil)
	_ = http.ListenAndServe(address, nil)
	fmt.Println("Сервер запущен...")
////////////////////////////////////////////

	brain.RunInitialisation()// init.go
	brain.Puls()
	// gomeostas.LiveParams[0]=0

///////////////////////////////////////////
	// в самом конце
	closer.Hold()
}
/////////////////////////////////////////////////////////////////////////////////
func cleanupFunc() {
	lib.WritePultConsol("Бот вырубается.")
	fmt.Print("ПОСЛЕДНИЕ ДЕЙСТВИЯ ПЕРЕД ЗАКРЫВАНИЕМ ПРОГРАММЫ")
	// записать текущее состояние Дерева Моделей и Эпизодическую память
	//	brain.PrepareBeforCloseTreeModel()
	/* если внезапно откобчить мозг человека, то из памяти пропадет все, что было в последние полчаса
	так что просто записывать PrepareBeforCloseTreeModel() раз в 10 минут и при создании нового узла дерева
	*/
	gomeostas.SaveCurrentGomeoParams()

	reflexes.SaveReflexesAttributes()
}
///////////////////////////////////////////////////////////////


// здесь могут быть функции для обеспечения связи между пакетами чтобы избегать цикличного импорта